/*  www.sgm.siedlce.pl

test detekcji 2 kanalow odbiornika RC
w oparciu o przerwania;
obsługa przerwan --> procedury:
void pulse_rising()
void pulse_falling()

pomiar czasu --> standardowa funkcja micros()

*/

//deklaracje ziennych

volatile int pulse1_start = 0;  //zmienne dla czasu
volatile int pulse2_start = 0; 

int pulse1_micros = 0;          //zmienne na dlugosc impulsow
int pulse2_micros = 0;          //kanalowych PPM

// inicjalizacja programu

void setup() {
  //inicjalizacja portu szeregowego (prezentacja danych)
  Serial.begin(115200); 
  //inicjalizacja przerwan --> 0 (pin 2, Arduino UNO)
  //                       --> 1 (pin 3, Arduino UNO)
  attachInterrupt(0, pulse1_rising, RISING);
  attachInterrupt(1, pulse2_rising, RISING);
}


void loop() {
  
  // tutaj ew. program uzytkowy, bazujacy na zmierzonym
  // czasie trwania impulsu kanalowego PPM
  
  
  //obsulga zmiennych do drukowania pomiaru na port szeregowy 
  static unsigned long t_start = millis();
  unsigned long t_print_count = millis(); 
  
  //jesli uplynelo 500msec to drukuj
  if ((t_print_count - t_start) >= 500) 
  {
    t_start = t_print_count;
    Serial.print("pulse1 = "); Serial.print(pulse1_micros);
    Serial.print(";   pulse2 = "); Serial.println(pulse2_micros);
    
  }

} // koniec glownej petli



// obsluga przerwania 0 (rising)
void pulse1_rising() {
  attachInterrupt(0, pulse1_falling, FALLING);
  pulse1_start = micros();
}

// obsluga przerwania 0 (falling) 
void pulse1_falling() {
  attachInterrupt(0, pulse1_rising, RISING);
  pulse1_micros = micros()-pulse1_start;
  //pulse1_micros = pulse1_value; 
}

// obsluga przerwania 1 (rising)
void pulse2_rising() {
  attachInterrupt(1, pulse2_falling, FALLING);
  pulse2_start = micros();
}

// obsluga przerwania 1 (falling) 
void pulse2_falling() {
  attachInterrupt(1, pulse2_rising, RISING);
  pulse2_micros = micros()-pulse2_start; 
}



